local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local ScarfPriority = function(player)
			if player.mo.doublesickle
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"The Double Sickle")
			end
			if player.mo.sworddash
				CBW_Battle.SetPriority(player,1,2,nil,1,2,"Float Dash")
			end
			if player.mo.swordjump
				CBW_Battle.SetPriority(player,1,4,nil,1,4,"Gravity Jump")
			end
			if player.mo.lightburst
				CBW_Battle.SetPriority(player,20,0,nil,20,0,"Light Burst")
			end
			if player.scarf_boostmode == 4
			and not player.mo.sworddash
				CBW_Battle.SetPriority(player,2,2,nil,2,2,"Nitro Boost")
			end
			if player.homing
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Plasma Homing")
			end
		end
		local ScarfBattle = function(mo,doaction,pressedaction)
			local player = mo.player
			if mo.lightburst
			or mo.doublesickle
			or mo.sworddash
			or mo.swordjump
			or mo.scarfplasmabattle
			or mo.player.scarf_boostmode == 4
				player.canguard = false
			end
			//if not(CBW_Battle.CanDoAction(player))
				//player.actionstate = 0
				//player.canguard = false
				//return
			//end
			if P_IsObjectOnGround(mo)
				player.actiontext = "Light Burst"
				player.actionrings = 10	
			else
				player.actiontext = "Energy Plasma"
				player.actionrings = 10
			end
			if player.actionstate != 0
				player.canguard = false
			end
			if player.actionstate == 0
			and not mo.scarfplasmabattle
			and not mo.doublesickle
				if doaction == 1
					if P_IsObjectOnGround(mo)
						S_StartSound(mo, sfx_s3k78)
						S_StartSound(mo, sfx_s3k60)
						S_StartSound(mo, sfx_lghtbt)
						P_ResetPlayer(player)
						player.powers[pw_nocontrol] = 2
						mo.lightburst = 58
						S_StartSound(player.mo, sfx_s3k5f)
						local lightburst = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_LIGHTBURST)
						if lightburst and lightburst.valid
							lightburst.target = mo
							if P_PlayerInPain(player)
							or (CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
							or player.playerstate == PST_DEAD
							or player.mo.state == S_PLAY_PAIN
							or player.mo.sprite2 == SPR2_PAIN
							or player.powers[pw_justsprung]
							or (player.mo.eflags & MFE_SPRUNG)
								P_RemoveMobj(lightburst)
							end
						end
						CBW_Battle.PayRings(player)
						mo.state = S_PLAY_LIGHTBURST1
						mo.doublesickle = 0
						mo.swordjump = 0
						mo.sworddash = 0
						CBW_Battle.ApplyCooldown(player,TICRATE*5)
					else
						CBW_Battle.PayRings(player)
						S_StartSound(mo,sfx_s3k7a)
						mo.scarfplasmabattle = 1*TICRATE
						CBW_Battle.ApplyCooldown(player, 6*TICRATE)
					end
				end
			end
		end
	CBW_Battle.SkinVars["scarf"] = {
		weight = 100,
		special = ScarfBattle,
		func_priority_ext = ScarfPriority
	}
	print("Scarf The Wolf Battle Mode support has been added!")
end)